use pqcrypto_falcon::falcon256::*;
use pqcrypto_traits::sign::PublicKey;
use pqcrypto_traits::sign::DetachedSignature;
use pqcrypto_traits::sign::SecretKey;
use std::env;
use std::{io::prelude::*, fs::File};
use std::fs;

//////////////////////////////////////////////////////////////////////////
/*  steps:
    1)take filename as commandline argument and assign variable to txt file
    2) convert message to char array
    2) take char array and convert each char to decimal value
    3) save decimal message and signature and public key to files
        (therefore deleting secret key making it impossible to replicate)
    4) open files in python
    5)append rust values to socket message and Signed
    5) on middlebox, seperate message, public key and signature to variables
    6) verify detached signature
    7) pop champagne! */
///////////////////////////////////////////////////////////////////////////

fn main() -> std::io::Result<()> {
    let args: Vec<String> = env::args().collect();

    let file_path = &args[1];

    let contents = fs::read_to_string(file_path)
        .expect("Something went wrong reading the file");
    
    let contents_bytes = contents.as_bytes();
    println!("{:?}", contents_bytes);
    let mut message_f = File::create("message.txt")?;
    message_f.write_all(contents_bytes)?;

    let (pk, sk) = keypair();
    let mut publickey_f = File::create("publickey.txt")?;
    publickey_f.write_all(&pk.as_bytes())?;

    let sig = detached_sign(&contents_bytes, &sk);
    let mut signature_f = File::create("signature.txt")?;
    signature_f.write_all(&sig.as_bytes())?;
    //file.sync_all()?;
    Ok(())
    /*
    let message = [0, 1, 2, 3, 4, 5];//vec![0, 1, 2, 3, 4, 5];
    let (pk, sk) = keypair();
    let sig = detached_sign(&message, &sk);
    
    println!("Public Key");
    println!("{:?}", &pk.as_bytes());
    println!("Secret Key");
    println!("{:?}", &sk.as_bytes());
    
    println!("Signed Message");
    println!("{:?}", &sm.as_bytes());
    let verifiedmsg = verify_detached_signature(&sig, &msg, &pk).unwrap();
    println!("{:?}", message);
    println!("{:?}", verifiedmsg);
   // assert!(verifiedmsg != message);
   */
}