//! # falcon
//!
//! This crate provides bindings to and wrappers around the following
//! implementations from [PQClean][pqc]:
//!
//! * falcon-256 - clean
//! [pqc]: https://github.com/pqclean/pqclean/
//!

#![allow(clippy::len_without_is_empty)]

pub mod ffi;

pub mod falcon256;

pub use crate::falcon256::{
    detached_sign as falcon256_detached_sign, keypair as falcon256_keypair, open as falcon256_open,
    public_key_bytes as falcon256_public_key_bytes, secret_key_bytes as falcon256_secret_key_bytes,
    sign as falcon256_sign, signature_bytes as falcon256_signature_bytes,
    verify_detached_signature as falcon256_verify_detached_signature,
};
